app/dash/forms.py
from flask_wtf import FlaskForm, RecaptchaField
from wtforms import StringField, IntegerField, PasswordField, BooleanField, SubmitField, validators, SelectField, TextAreaField, DateField
from wtforms.validators import ValidationError, DataRequired, Email, EqualTo, Length
from flask_ckeditor import CKEditorField 
from ..models import User, Package, Contact, Trial, Tuto, Subscription, Offer, Temps

class Settingform(FlaskForm):

	api_infos = StringField('Getting Infos : ')
	api_create = StringField('Create Newline : ')
	api_mag = StringField('Create Mag device Api : ')
	api_enigma = StringField('Create Enigma device Api : ')
	m3u = StringField('M3u : ')
	server = StringField('Main Server : ')
	paypal_id = StringField('Paypal Identifier : ')


	#recaptcha = RecaptchaField()
	submit = SubmitField('Save')


class UserInfo(FlaskForm):
	current_password = PasswordField('Current Password', validators=[DataRequired(), validators.Length(min=4)])

	new_password = PasswordField(validators=[
										DataRequired(),
										validators.Length(min=4),
										EqualTo('confirm_password')
										])

	confirm_password = PasswordField('Confirm Password')

	#recaptcha = RecaptchaField()

	submit = SubmitField('Change Password')

class fast_email(FlaskForm):

	email = StringField('Email', validators=[DataRequired(), Email()])

	txt = CKEditorField('Message')

	#recaptcha = RecaptchaField()
	
	submit = SubmitField('Send')

class Newoffer(FlaskForm):

	title = StringField('Title', validators=[DataRequired()])

	txt = CKEditorField('Text', validators=[DataRequired()])

	img = StringField('Image url', validators=[DataRequired()])

	fin = StringField('Fin Date', validators=[DataRequired()])

	coupon = StringField('Coupon', validators=[DataRequired()])

	price = StringField('Price', validators=[DataRequired()])

	is_closed  = BooleanField('Make this Offer Active', default=False)

	tags = StringField('Tags', validators=[DataRequired()])

	submit = SubmitField('Save')

class NewTemp(FlaskForm):

	title = StringField('Title', validators=[DataRequired()])

	txt = CKEditorField('Description', validators=[DataRequired()])

	img = StringField('Image url')

	is_closed = BooleanField('ON/OFF')

	submit = SubmitField('Save')

	def validate_name(self, title):
		temps = Temps.query.filter_by(title=title.data).first()
		if temps is not None:
			raise ValidationError('Please use a different Title.')

class Newtuto(FlaskForm):

	title = StringField('Title', validators=[DataRequired()])

	txt = CKEditorField('Description', validators=[DataRequired()])

	img = StringField('Image url', validators=[DataRequired()])

	tags = StringField('Tags', validators=[DataRequired()])

	submit = SubmitField('Save')

	def validate_name(self, title):
		tutorial = Tuto.query.filter_by(title=title.data).first()
		if tutorial is not None:
			raise ValidationError('Please use a different Title.')

class NComment(FlaskForm):

	msg = TextAreaField('Message', validators=[DataRequired()])
	submit = SubmitField('Send')
	#recaptcha = RecaptchaField(

class Newticket(FlaskForm):

	sub = SelectField('Subject', choices=[('Need help', 'Need help'),('Reseller program', 'Reseller program'), ('Affilate program', 'Affilate program'), ('Ask for sales', 'Ask for sales'), ('Autre', 'Autre')])
	priotiy = SelectField('Priotiy', choices=[('HIGHT', 'HIGHT'), ('MEDIUM', 'MEDIUM'), ('LOW', 'LOW')])
	msg = TextAreaField('Message', validators=[DataRequired()])
	#recaptcha = RecaptchaField()
	submit = SubmitField('Open Ticket')

class Newtrial(FlaskForm):

	country_selector = StringField('Full name', validators=[DataRequired()])
	email_rec = StringField('Email', validators=[DataRequired(), Email()])
	device_type = SelectField('Device Type', choices=[('Android', 'Android'), ('Smart Tv', 'Smart Tv'), ('Receiver', 'Receiver'), ('Apple Tv', 'Apple Tv'), ('PC', 'PC')])

	#recaptcha = RecaptchaField()

	#submit = SubmitField('Request')

	def validate_email_rec(self, email_rec):
		trial = Trial.query.filter_by(email_rec=email_rec.data).first()
		if trial is not None:
			raise ValidationError('Trial already sent to you , please check your inbox.')


class Neworder(FlaskForm):
	
	f_name = StringField('Full Name')

	email = StringField('Email', validators=[DataRequired(), Email()])

	#confirm_email = StringField('Confirm Email', validators=[DataRequired(),EqualTo('confirm_email')])

	country_selector = StringField('Location')

	device_type = SelectField('Device Type', choices=[('ANDROID', 'Android'), ('SMART TV', 'Smart Tv'), ('RECEIVER', 'Receiver'), ('APPLE TV', 'Apple Tv'), ('PC', 'PC'), ('Mag', 'Mag'), ('Enigma', 'Enigma')])

	phone_num = StringField('Phone Number')

	#cuppon = StringField('Coupon *not required*', validators=None)

	note = TextAreaField('Note About Order')

	#recaptcha = RecaptchaField()
	
	submit = SubmitField('Create order')

class Newuser(FlaskForm):

	email = StringField('Email', validators=[DataRequired(), Email()])

	username = StringField(validators=[DataRequired()])

	password = PasswordField(validators=[DataRequired(),validators.Length(min=10)])

	is_admin  = BooleanField('Add User To Administrators', default=False)

	is_reseller  = BooleanField('Add User To Resellers', default=False)

	is_subscriber = BooleanField('Add User to Subscribers', default=False)

	is_active = BooleanField('Block user', default=False)


	submit = SubmitField('Save')


class Email_send(FlaskForm):

	email = StringField('Email', validators=[DataRequired(), Email()])

	recaptcha = RecaptchaField()

	submit = SubmitField('Send')

class Userform(FlaskForm):

	credit = StringField('Credit')

	is_admin  = BooleanField('Add User To Administrators', default=False)

	is_reseller  = BooleanField('Add User To Resellers', default=False)

	is_subscriber = BooleanField('Add User to Subscribers', default=False)

	is_active = BooleanField('Block user', default=False)

	#status = SelectField('Status of User', choices=[('R', '12'), ('06', '06'), ('03', '03')])

	affiliate_code = StringField('Affiliate Code')

	m3u = StringField('M3u Link')

	email_confirmed = BooleanField('Confirm Email of User', default=False)

	submit = SubmitField('Save')

class Addpackage(FlaskForm):

	name = StringField('Package Name', validators=[DataRequired()])

	img = StringField('Image url', validators=[DataRequired()])

	period = SelectField('Period / Months', choices=[('12', '12'), ('06', '06'), ('03', '03')])

	quality = SelectField('Quality', choices=[('4K|HD|SD|LOW', '4K|HD|SD|LOW'), ('HD|SD|LOW', 'HD|SD|LOW')])

	channels = StringField('Channels', validators=[DataRequired()])

	vod = SelectField('Type Vod', choices=[('Yes', 'yes'), ('No', 'no')])

	price = StringField('Price $', validators=[DataRequired()])

	xtream_id = IntegerField('ID of xtream-ui package')

	submit = SubmitField('Add Package')

app/dash/__init__.py
from flask import Blueprint

dash = Blueprint('dash', __name__)

from . import views

app/dash/views.py
# -*- coding: utf-8 -*-
from flask import Blueprint, abort, flash, g, jsonify, redirect, \
	render_template, request, url_for, jsonify, json, Markup, make_response
from flask_login import login_required, login_user, current_user, logout_user
from sqlalchemy.orm import subqueryload
from sqlalchemy import desc, update, insert
from . import dash
from .. import db
from ..models import User, Setting, Comment, Reseller, Temps, Package, Contact, Trial, Tuto, Subscription, Support, Offer, Reseller, init_db, Base, engine
import requests
import json
from threading import Thread, Lock
from flask import current_app
from app import mail, Message
from .forms import Userform, Settingform, NComment, NewTemp, Addpackage, Newuser, Neworder, Newtrial, Newticket, Newtuto, Newoffer, fast_email, UserInfo

import http.client
import smtplib, ssl
import urllib.request
import urllib.parse


def check_admin():

	if not current_user.is_admin:
		abort(403)

def send_async_email(app, msg):
	with app.app_context():
		mail.send(msg)



@dash.route('/index', methods=['GET','POST'])
@login_required
def index():
	check_admin()
	data = {}
	data['ress'] = Reseller.query.order_by(desc(Reseller.id)).limit(4)
	data['messages'] = Contact.query.order_by(desc(Contact.id)).limit(4)
	data['supports'] = Support.query.order_by(desc(Support.id)).limit(4)
	data['users'] = User.query.order_by(desc(User.id)).limit(1)
	data['subscriptions'] = Subscription.query.order_by(desc(Subscription.id)).limit(1)
	data['tutos'] = Tuto.query.all()
	data['tickets'] = Support.query.order_by(desc(Support.id)).limit(1)
	data['ticketts'] = Support.query.order_by(desc(Support.id)).limit(4)
	data['rescount'] = Reseller.query.count()
	data['regcount'] = User.query.count()
	data['subcount'] = Subscription.query.count()
	data['tutocount'] = Tuto.query.count()

	return render_template('/dash/index.html', data=data, title='New Dashboard')

@dash.route('/resellers/show/<int:resellers_id>/', methods=['GET','POST'])
@login_required
def show_resellers(resellers_id):
	check_admin()

	res = Reseller.query.get(resellers_id)

	return render_template('/dash/reseller.html', res = res, title='Resellers Details')

@dash.route('/resellers/newreseller', methods=['GET','POST'])
@login_required
def add_resellers():
	check_admin()


	return render_template('/dash/new_reseller.html', title='New Reseller')

@dash.route('/icons', methods=['GET','POST'])
@login_required
def icons():
	check_admin()

	return render_template('/dash/icons.html', title='New Icons')

@dash.route('/api_setting/<int:api_id>/', methods=['GET','POST'])
@login_required
def api_setting(api_id):
	check_admin()

	apis = Setting.query.get(api_id)
	form = Settingform()
	if form.validate_on_submit():
		apis.api_infos = form.api_infos.data
		apis.api_create = form.api_create.data
		apis.api_mag = form.api_mag.data
		apis.api_enigma = form.api_enigma.data
		apis.m3u = form.m3u.data
		apis.server = form.server.data
		apis.paypal_id = form.paypal_id.data
		db.session.commit()
		#flash('Your Package Has been Updated !', 'success')
		flash('Setting Saved for and pointed to server : {}'.format(apis.server), 'success')
		return redirect(url_for('dash.index', api_id=2))
	elif request.method == 'GET':
		form.api_infos.data = apis.api_infos
		form.api_create.data = apis.api_create
		form.api_mag.data = apis.api_mag
		form.api_enigma.data = apis.api_enigma
		form.m3u.data = apis.m3u
		form.server.data = apis.server
		form.paypal_id.data = apis.paypal_id
	return render_template('/dash/api.html', form=form, title='Api Setting')

@dash.route('/templates/new', methods=['GET','POST'])
@login_required
def newtemp():
	check_admin()

	form = NewTemp()
	if form.validate_on_submit():
		newtemp = Temps(title=form.title.data,txt=form.txt.data,img=form.img.data,is_closed=form.is_closed.data,user_id=current_user.id)
		db.session.add(newtemp)
		db.session.commit()
		flash('Template created for  : {} successfly'.format(newtemp.title), 'primary')
		return redirect(url_for('dash.temps'))

	return render_template('/dash/newtemp.html', form=form, title='New Templates')

@dash.route('/templates/', methods=['GET','POST'])
@login_required
def temps():
	check_admin()
	data = {}
	data['temps'] = Temps.query.all()
	return render_template('/dash/temps.html', data=data, title='Templates messages')

@dash.route('/templates/edit/<int:templates_id>/', methods=['GET', 'POST'])
@login_required
def edittemps(templates_id):
	check_admin()
	templates = Temps.query.get(templates_id)
	form = NewTemp()
	if form.validate_on_submit():
		templates.title = form.title.data
		templates.txt = form.txt.data
		templates.img = form.img.data
		templates.is_closed = form.is_closed.data
		db.session.commit()
		#flash('Your Package Has been Updated !', 'success')
		flash('Template Edited : {}'.format(templates.title), 'success')
		return redirect(url_for('dash.temps', templates_id=templates.id))
	elif request.method == 'GET':
		form.title.data = templates.title
		form.txt.data = templates.txt
		form.img.data = templates.img
		form.is_closed.data = templates.is_closed

	return render_template('/dash/newtemp.html', form=form, title='Edit Template', legend='Edit Tutorial')


@dash.route('/templates/delete/<int:id>/', methods=['GET','POST'])
@login_required
def deltemp(id):
	check_admin()

	temps = Temps.query.get(id)
	db.session.delete(temps)
	db.session.commit()
	#flash('You have successfully delete User', "success")
	flash('Template Deleted : {}'.format(temps.title), 'primary')

	# redirect to the departments page
	return redirect(url_for('dash.temps'))
	return render_template(title="Delete Tutorial")
@dash.route('/registred-users', methods=['GET','POST'])
@login_required
def registred():
	check_admin()
	data = {}
	data['users'] = User.query.all()

	form = Newuser()
	if form.validate_on_submit():
		newuser = User(email=form.email.data,username=form.username.data,password=form.password.data,is_admin=form.is_admin.data,is_reseller=form.is_reseller.data,is_subscriber=form.is_subscriber.data)
		db.session.add(newuser)
		db.session.commit()
		flash('User added : {} successfly'.format(newuser.username), 'primary')
		return redirect(url_for('dash.registred'))
	
	return render_template('/dash/registred-users.html', form = form, data=data, title='Registred users')

@dash.route('/subscriptions', methods=['GET','POST'])
@login_required
def subscriptions():
	check_admin()
	data = {}
	data['subscriptions'] = Subscription.query.all()
	data['packages'] = Package.query.all()

	form = Neworder()
	if form.validate_on_submit():
		newuser = Subscription(f_name=form.f_name.data,email=form.email.data,country_selector=form.country_selector.data,device_type=form.device_type.data,phone_num=form.phone_num.data,pack=request.args.get('pack_id'))
		db.session.add(newuser)
		db.session.commit()
		flash('Subscription created for  : {} successfly'.format(newuser.f_name), 'primary')
		return redirect(url_for('dash.subscriptions'))

	return render_template('/dash/subscription.html', form=form, data=data, title='Subscriptions')

@dash.route('/trials-requests', methods=['GET','POST'])
@login_required
def trials():
	check_admin()
	data = {}
	data['trials'] = Trial.query.all()
	data['packages'] = Package.query.all()

	form = Newtrial()
	if form.validate_on_submit():
		newuser = Trial(country_selector=form.country_selector.data,email_rec=form.email_rec.data,device_type=form.device_type.data)
		db.session.add(newuser)
		db.session.commit()
		flash('Trial created for  : {} successfly'.format(newuser.full_name), 'primary')
		return redirect(url_for('dash.trials'))

	return render_template('/dash/trial.html', form=form, data=data, title='Trial requests')

@dash.route('/trials-requests/delete/<int:id>/', methods=['GET','POST'])
@login_required
def deltrial(id):
	check_admin()

	trials = Trial.query.get(id)
	db.session.delete(trials)
	db.session.commit()
	#flash('You have successfully delete User', "success")
	flash('Trial Deleted : {}'.format(trials.email_rec), 'primary')

	# redirect to the departments page
	return redirect(url_for('dash.trials'))
	return render_template(title="Delete Trial")

@dash.route('/tutorials', methods=['GET','POST'])
@login_required
def tutorials():
	check_admin()
	data = {}
	data['tutos'] = Tuto.query.all()

	return render_template('/dash/tutorial.html', data=data, title='Tutorials')

@dash.route('/tutorials/new', methods=['GET','POST'])
@login_required
def newtuto():
	check_admin()
	form = Newtuto()
	if form.validate_on_submit():
		post = Tuto(title=form.title.data,txt=form.txt.data,img=form.img.data,tags=form.tags.data,user_id=current_user.id)
		db.session.add(post)
		db.session.commit()
		flash('Tutorial created : {}'.format(post.title), 'success')
		return redirect(url_for('dash.tutorials'))

	return render_template('/dash/newtutorial.html', form=form, title='Create Tutorial', legend="New tutorial")

@dash.route('/tutorials/edit/<int:tutorials_id>/', methods=['GET', 'POST'])
@login_required
def edittuto(tutorials_id):
	check_admin()

	tutorials = Tuto.query.get(tutorials_id)
	form = Newtuto()

	if form.validate_on_submit():

		tutorials.title = form.title.data
		tutorials.txt = form.txt.data
		tutorials.img = form.img.data
		tutorials.tags = form.tags.data

		db.session.commit()

		#flash('Your Package Has been Updated !', 'success')
		flash('Tutorial Edited : {}'.format(tutorials.title), 'success')

		return redirect(url_for('dash.tutorials', tutorials_id=tutorials.id))

	elif request.method == 'GET':

		form.title.data = tutorials.title
		form.txt.data = tutorials.txt
		form.img.data = tutorials.img
		form.tags.data = tutorials.tags

	return render_template('/dash/newtutorial.html', form=form, title='Edit Tutorial', legend='Edit Tutorial')

@dash.route('/tutorials/delete/<int:id>/', methods=['GET','POST'])
@login_required
def deltuto(id):
	check_admin()

	tutos = Tuto.query.get(id)
	db.session.delete(tutos)
	db.session.commit()
	#flash('You have successfully delete User', "success")

app/templates/dash/addpack.html
{% import "bootstrap/utils.html" as utils %}
{% import "bootstrap/wtf.html" as wtf %}
{% from "_formhelpers.html" import render_field %}
{% extends "Dash_layout.html" %}
{% block content %}   
<div class="page-wrapper">
    <div class="container-fluid">


            <h1>New Package </h1>
            <p>Insert new package in system and official landing page of the website.</p><br>
            <div>
              <a href="{{ url_for('dash.packages')}}" class="btn btn-success"><i class="m-r-10 mdi mdi-package"></i> Packages</a>
            </div>

            <center>
                {% if error %}
                <p class=error><strong>Error:</strong> {{ error }}
                {% endif %}
                <br>
                {% with messages = get_flashed_messages(with_categories=true) %}
                {% if messages %}
                <div class="alert alert-{{ messages.0.0 }}" role="alert">
                {% for category, message in messages %}
                {{ message }} </br>
                {% endfor %}
                *</div>
                {% endif %}
                {% endwith %}
                </center>
                <br>

                <div class="container">
                    <div class="card">
                        <div class="card-body">
                            <form class="form-horizontal form-material" method="POST">
                                {{ form.csrf_token }}
                                <div class="form-group">
                                    <label class="col-md-12">Package name : </label>
                                    <div class="col-md-12">
                                        {{ form.name(rows=3, class_="form-control form-control-line")}}
                                    </div>
                                    {% for error in form.name.errors %}<span style="color: red;">{{ error }}</span>{% endfor %}
                                </div>
                                <div class="form-group">
                                    <label class="col-md-12">Image url : </label>
                                    <div class="col-md-12">
                                        {{ form.img(rows=3, class_="form-control form-control-line")}}
                                    </div>
                                    {% for error in form.img.errors %}<span style="color: red;">{{ error }}</span>{% endfor %}
                                </div>
                                <div class="form-group">
                                    <label for="example-email" class="col-md-12">Package time : </label>
                                    <div class="col-md-12">
                                       
                                            {{ form.period(rows=3, class_="form-control form-control-line")}}
                                    </div>
                                    {% for error in form.period.errors %}<span style="color: red;">{{ error }}</span>{% endfor %}
                                </div>
                                <div class="form-group">
                                    <label class="col-md-12">Quality : </label>
                                    <div class="col-md-12">
                                        {{ form.quality(rows=3, class_="form-control form-control-line")}}
                                    </div>
                                    {% for error in form.quality.errors %}<span style="color: red;">{{ error }}</span>{% endfor %}
                                </div>
                                <div class="form-group">
                                    <label class="col-md-12">Channels : </label>
                                    <div class="col-md-12">
                                        {{ form.channels(rows=3, class_="form-control form-control-line", type="number")}}
                                    </div>
                                    {% for error in form.channels.errors %}<span style="color: red;">{{ error }}</span>{% endfor %}
                                </div>
                                <div class="form-group">
                                    <label class="col-md-12">Vod total : </label>
                                    <div class="col-md-12">
                                        {{ form.vod(rows=3, class_="form-control form-control-line", type="number")}}
                                    </div>
                                    {% for error in form.vod.errors %}<span style="color: red;">{{ error }}</span>{% endfor %}
                                </div>
                                <div class="form-group">
                                    <label class="col-md-12">Price : </label>
                                    <div class="col-md-12">
                                        {{ form.price(rows=3, class_="form-control form-control-line")}}
                                    </div>
                                    {% for error in form.price.errors %}<span style="color: red;">{{ error }}</span>{% endfor %}
                                </div>
                                <div class="form-group">
                                    <label class="col-md-12">XUI ID : </label>
                                    <div class="col-md-12">
                                        {{ form.xtream_id(rows=3, class_="form-control form-control-line", type="number")}}
                                    </div>
                                    {% for error in form.xtream_id.errors %}<span style="color: red;">{{ error }}</span>{% endfor %}
                                </div>
                          
                           
                                <div class="form-group">
                                    <div class="col-sm-12">
                                        <button class="btn btn-success" name="submit">Save</button>
                                    </div>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
                

    </div>
</div>


    {% endblock content %}

app/templates/dash/api.html
{% import "bootstrap/utils.html" as utils %}
{% import "bootstrap/wtf.html" as wtf %}
{% from "_formhelpers.html" import render_field %}
{% extends "Dash_layout.html" %}
{% block content %}   
<div class="page-wrapper">
    <div class="container-fluid">


            <h1>Api Setting </h1>
            <p>Please insert all the api urls to success connection between systems .</p><br>

            <center>
                {% if error %}
                <p class=error><strong>Error:</strong> {{ error }}
                {% endif %}
                <br>
                {% with messages = get_flashed_messages(with_categories=true) %}
                {% if messages %}
                <div class="alert alert-{{ messages.0.0 }}" role="alert">
                {% for category, message in messages %}
                {{ message }} </br>
                {% endfor %}
                *</div>
                {% endif %}
                {% endwith %}
                </center>
                <br>

                <div class="container">
                    <div class="card">
                        <div class="card-body">
                            <form class="form-horizontal form-material" method="POST">
                                {{ form.csrf_token }}
                                <div class="form-group">
                                 
                                    <div class="col-md-12">
                                        {{ wtf.quick_form(form) }}
                                    </div>
                                 
                                </div>

                            </form>
                        </div>
                    </div>
                </div>
                

    </div>
</div>


    {% endblock content %}

app/templates/dash/inbox.html
{% import "bootstrap/utils.html" as utils %}
{% import "bootstrap/wtf.html" as wtf %}
{% from "_formhelpers.html" import render_field %}
{% extends "Dash_layout.html" %}
{% block content %}   
<div class="page-wrapper">
    <div class="page-breadcrumb">
        <div class="row align-items-center">
            <div class="col-5">
                <h4 class="page-title">Reseller Details</h4>
            </div>
        </div>
    </div>

    <div class="container-fluid">
        <div class="row">
            <h2>ljkjljkl</h2>
        </div>
    </div>
</div>
            
            
{% endblock content %}

app/templates/dash/tutorial.html
{% import "bootstrap/utils.html" as utils %}
{% import "bootstrap/wtf.html" as wtf %}
{% from "_formhelpers.html" import render_field %}
{% extends "Dash_layout.html" %}
{% block content %}   

<link href="/static/dash/css/jquery.dataTables.min.css" rel="stylesheet" media="screen">

<script src="/static/dash/js/jquery-3.5.1.js"></script>

<script type="text/javascript">$(document).ready(function() {
    $('#example').DataTable( {
        "scrollX": true
    } );
} );</script>

<div class="page-wrapper">
    <div class="container-fluid">


            <h1>Tutorials</h1>
            <p>All post and tutorial found on the system.</p>

            <a href="{{ url_for('dash.newtuto')}}" class="btn btn-dark"><i class="m-r-10 mdi mdi-newspaper"></i> New Tutorial</a>
            
            <br>


            <center>
                {% if error %}
                <p class=error><strong>Error:</strong> {{ error }}
                {% endif %}
                <br>
                {% with messages = get_flashed_messages(with_categories=true) %}
                {% if messages %}
                <div class="alert alert-{{ messages.0.0 }}" role="alert">
                {% for category, message in messages %}
                {{ message }} </br>
                {% endfor %}
                *</div>
                {% endif %}
                {% endwith %}
                </center>
                <br>
                <table id="example" class="display" style="width:100%">
                    <thead>
                        <tr>
                            <th>Image</th>
                            <th>Title</th>
                            <th>Owner</th>
                            <th>Posted at</th>
                            <th>Setting</th>
                        </tr>
                    </thead>
                    <tbody>
                        {% for tuto in data.tutos %}
                        <tr>
                            <td><img class="thumbnail img-responsive rounded-circle" width="100" height="100" src="{{tuto.img}}"/></td>
                            <td>{{tuto.title}}</td>
                            <td>{{tuto.users.username}}</td>
                            <td>{{tuto.tuto_time.strftime('%A,%d,%Y || %H:%M')}}</td>
                            <td>
                                <a href="{{ url_for('dash.edittuto', tutorials_id=tuto.id) }}" class="m-r-10 mdi mdi-credit-card-scan label label-success" title="Open Tutorial"></a>

                                <a href="" class="m-r-10 mdi mdi-delete label label-danger" data-toggle="modal" data-target="#exampleModal" title="Delete Tutorial"></a>
                                <div class="modal fade" id="exampleModal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
                                    <div class="modal-dialog">
                                      <div class="modal-content">
                                        <div class="modal-header">
                                          <h5 class="modal-title" id="exampleModalLabel"><i class=" mdi mdi-delete-forever"></i> Delete confirmation !</h5>
                                          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                            <span aria-hidden="true">&times;</span>
                                          </button>
                                        </div>
                                        <div class="modal-body">
                                         Tutorial will delete  :  <b style='color:red;'>{{tuto.title}}.</b> forever .!
                                        </div>
                                        <div class="modal-footer">
                                          <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                                            <a class="btn btn-danger" href="{{ url_for('dash.deltuto', id=tuto.id) }}"><i class=" mdi mdi-delete-forever"></i> Delete</a>
                                        </div>
                                      </div>
                                    </div>
                                  </div>
                            </td>
                        </tr>
                        {% endfor %}
                   
           
                    </tfoot>
                </table>
    </div>
</div>

{% endblock content %}